## ion 0.0.20020207

=== libtu-20020119/Makefile ===
##
## libtu Makefile
##

# System-specific configuration is in system.mk
include system.mk

######################################

INCLUDES += -I./include
CFLAGS += $(POSIX_SOURCE)

OBJS= misc.o output.o util.o optparser.o parser.o tokenizer.o map.o

ifdef LIBTU_NO_ERRMSG
DEFINES += -DLIBTU_NO_ERRMSG
else
ifndef HAS_SYSTEM_ASPRINTF
OBJS += snprintf_2.2/snprintf.o
else
DEFINES += -DHAS_SYSTEM_ASPRINTF
endif
endif

TARGETS=libtu.a
TESTERS=tester tester2 tester3

######################################

include rules.mk

######################################

testers: $(TESTERS)

libtu.a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $+
	$(RANLIB) $@
	
tester: tester.c libtu.a
	$(CC) $(CFLAGS) $< -L. -ltu -lm -o $@

tester2: tester2.c libtu.a
	$(CC) $(CFLAGS) $< -L. -ltu -lm -o $@

tester3: tester3.c libtu.a
	$(CC) $(CFLAGS) $< -L. -ltu -lm -o $@

_install:
	$(INSTALLDIR) $(LIBDIR)
	$(INSTALLDIR) $(INCDIR)/libtu
	$(INSTALL) -m $(DATA_MODE) libtu.a $(LIBDIR)
	for i in include/libtu/*.h; do \
		$(INSTALL) -m $(DATA_MODE) $$i $(INCDIR)/libtu; \
	done

=== src/Makefile ===
##
## Ion Makefile
##

# System-specific configuration is in system.mk
include ../system.mk

######################################

LIBS += -L../libtu -ltu -lm $(X11_LIBS) -lX11
#-lefence
INCLUDES += -I../libtu/include $(X11_INCLUDES)
DEFINES += -DETCDIR=\"$(ETCDIR)\"

CFLAGS += $(XOPEN_SOURCE) $(MODULE_SUPPORT)
LDFLAGS += $(MODULE_SUPPORT_LDFLAGS)

OBJS=	binding.o client.o clientwin.o complete.o complete_file.o confws.o \
	cursor.o draw.o edln.o event.o exec.o focus.o font.o frame.o readfds.o \
	frameid.o function.o key.o listing.o main.o obj.o pointer.o \
	property.o query.o readconfig.o resize.o screen.o selection.o \
	signal.o sizehint.o split.o thing.o wedln.o window.o winprops.o \
	workspace.o xic.o input.o wmessage.o splitmisc.o modules.o \
	command.o shortcut.o grab.o

TARGETS=ion

######################################

include ../rules.mk

######################################

ion: $(OBJS) $(EXT_OBJS)
	$(CC) $(OBJS) $(EXT_OBJS) $(LDFLAGS) -o $@

_install:
	$(INSTALLDIR) $(BINDIR)
	$(INSTALL) -m $(BIN_MODE) ion $(BINDIR)
	$(STRIP) $(BINDIR)/ion

## ion 2.5.3~dfsg1

=== arch-rtems/Makefile ===
IONFLAGS = -DRTEMS -DBP_EXTENDED -DGDSSYMTAB -DGDSLOGGER -DUSING_SDR_POINTERS \
-DION_NO_DNS -DNO_SDR_TRACE -DNO_PSM_TRACE -DNO_PROXY -DNO_DIRLIST

PGM=${ARCH}/ion.exe

# optional managers required
MANAGERS = io semaphore

ICISOURCES =     \
   platform.c    \
   platform_sm.c \
   memmgr.c      \
   llcv.c        \
   lyst.c        \
   psm.c         \
   smlist.c      \
   ion.c         \
   rfx.c         \
   zco.c         \
   sdrtable.c    \
   sdrhash.c     \
   sdrxn.c       \
   sdrmgt.c      \
   sdrstring.c   \
   sdrlist.c     \
   sdrcatlg.c    \
   rfxclock.c    \
   ionadmin.c    \
   sdrmend.c     \
   ionsec.c      \
   ionsecadmin.c 


BPSOURCES =      \
	libbp.c      \
	libbpP.c     \
	bpclock.c    \
	bpadmin.c    \
	bpstats.c    \
	bptrace.c    \
	bplist.c     \
	lgagent.c    \
	ipnadmin.c   \
	ipnfw.c      \
	libcgr.c     \
	ipnadminep.c \
	libipnfw.c   \
	ltpcli.c     \
	ltpclo.c     \
	bei.c        \
	ecos.c

#	phn.c        \

LTPSOURCES =     \
	libltp.c     \
	libltpP.c    \
	ltpclock.c   \
	ltpmeter.c   \
	pmqlsi.c     \
	pmqlso.c     \
	ltpadmin.c

BSPSOURCES =     \
	extbsputil.c \
	extbspbab.c  \
	crypto.c          

DTN2SOURCES =        \
	libdtn2fw.c 

CFDPSOURCES =      \
	bputa.c      \
	cfdpclock.c  \
	cfdpadmin.c  \
	libcfdp.c    \
	libcfdpP.c   \
	libcfdpops.c 

TESTSOURCES =      \
	bpsource.c   \
	bpsink.c

#	sptrace.c    \
#	bpstats2.c   \
#	bping.c      \
#	bpchat.c     \
#	bpcounter.c  \
#	bpdriver.c   \
#	bpecho.c     \
#	bpsendfile.c \
#	bprecvfile.c 

CSRCS = ionrtems.c $(ICISOURCES) $(BPSOURCES) $(LTPSOURCES) $(PXSOURCES) $(DTN2SOURCES) $(BSPSOURCES) $(CFDPSOURCES) $(TESTSOURCES)
COBJS = $(CSRCS:%.c=${ARCH}/%.o)

include $(RTEMS_MAKEFILE_PATH)/Makefile.inc
include $(RTEMS_CUSTOM)
include $(PROJECT_ROOT)/make/leaf.cfg

OBJS = $(COBJS) $(CXXOBJS) $(ASOBJS)

CFLAGS = -g -Wall -Werror $(IONFLAGS) -I../ici/include -I../dgr/include -I../ltp/include -I../bp/include -I../cfdp/include -I../ams/include -I. -O2

all:    ${ARCH} $(PGM)

$(PGM):	$(OBJS)
	$(make-exe)

clean:
	rm -f $(COBJS) $(PGM)

=== bp/doc/Makefile ===
PODM1 = pod2man -s 1 -c "BP executables"
PODM3 = pod2man -s 3 -c "BP library functions"
PODM5 = pod2man -s 5 -c "BP configuration files"
PODH = pod2html --noindex

MANFILES = \
	./man/man1/bpadmin.1 \
	./man/man1/bpclock.1 \
	./man/man1/bpcounter.1 \
	./man/man1/bpdriver.1 \
	./man/man1/bpecho.1 \
	./man/man1/bpsendfile.1 \
	./man/man1/bprecvfile.1 \
	./man/man1/bpsink.1 \
	./man/man1/bpsource.1 \
	./man/man1/bpstats.1 \
	./man/man1/bplist.1 \
	./man/man1/bpcancel.1 \
	./man/man1/bptrace.1 \
	./man/man1/brsccla.1 \
	./man/man1/brsscla.1 \
	./man/man1/dgrcla.1 \
	./man/man1/dtn2adminep.1 \
	./man/man1/dtn2admin.1 \
	./man/man1/dtn2fw.1 \
	./man/man1/ipnadminep.1 \
	./man/man1/ipnadmin.1 \
	./man/man1/ipnfw.1 \
	./man/man1/lgagent.1 \
	./man/man1/lgsend.1 \
	./man/man1/hmackeys.1 \
	./man/man1/ltpcli.1 \
	./man/man1/ltpclo.1 \
	./man/man1/stcpcli.1 \
	./man/man1/stcpclo.1 \
	./man/man1/tcpcli.1 \
	./man/man1/tcpclo.1 \
	./man/man1/udpcli.1 \
	./man/man1/udpclo.1 \
	./man/man1/dccpcli.1 \
	./man/man1/dccpclo.1 \
	./man/man5/bprc.5 \
	./man/man5/ipnrc.5 \
	./man/man5/dtn2rc.5 \
	./man/man5/lgfile.5 \
	./man/man3/bpextensions.3 \
	./man/man3/bp.3

HTMLFILES = \
	./html/man1/bpadmin.html \
	./html/man1/bpclock.html \
	./html/man1/bpcounter.html \
	./html/man1/bpdriver.html \
	./html/man1/bpecho.html \
	./html/man1/bpsendfile.html \
	./html/man1/bprecvfile.html \
	./html/man1/bpsink.html \
	./html/man1/bpsource.html \
	./html/man1/bpstats.html \
	./html/man1/bplist.html \
	./html/man1/bpcancel.html \
	./html/man1/bptrace.html \
	./html/man1/brsccla.html \
	./html/man1/brsscla.html \
	./html/man1/dgrcla.html \
	./html/man1/dtn2adminep.html \
	./html/man1/dtn2admin.html \
	./html/man1/dtn2fw.html \
	./html/man1/ipnadminep.html \
	./html/man1/ipnadmin.html \
	./html/man1/ipnfw.html \
	./html/man1/lgagent.html \
	./html/man1/lgsend.html \
	./html/man1/hmackeys.html \
	./html/man1/ltpcli.html \
	./html/man1/ltpclo.html \
	./html/man1/stcpcli.html \
	./html/man1/stcpclo.html \
	./html/man1/tcpcli.html \
	./html/man1/tcpclo.html \
	./html/man1/udpcli.html \
	./html/man1/udpclo.html \
	./html/man1/dccpcli.html \
	./html/man1/dccpclo.html \
	./html/man5/bprc.html \
	./html/man5/ipnrc.html \
	./html/man5/dtn2rc.html \
	./html/man5/lgfile.html \
	./html/man3/bpextensions.html \
	./html/man3/bp.html

ALL = $(MANFILES) $(HTMLFILES)

all:		$(ALL)

clean:
		rm -f man/man1/*.1
		rm -f man/man3/*.3
		rm -f man/man5/*.5
		rm -f html/man1/*.html
		rm -f html/man3/*.html
		rm -f html/man5/*.html
		rm -f *.tmp

install:
		cp man/man1/*.1 $(ROOT)/man/man1
		cp man/man3/*.3 $(ROOT)/man/man3
		cp man/man5/*.5 $(ROOT)/man/man5

#	-	-	Man files	-	-	-	-	-

./man/man1/%.1:	pod1/%.pod
		$(PODM1) $< $@

./man/man3/%.3:	pod3/%.pod
		$(PODM3) $< $@

./man/man5/%.5:	pod5/%.pod
		$(PODM5) $< $@

./html/man1/%.html:	pod1/%.pod
		$(PODH) --infile=$< --outfile=$@

./html/man3/%.html:	pod3/%.pod
		$(PODH) --infile=$< --outfile=$@

./html/man5/%.html:	pod5/%.pod
		$(PODH) --infile=$< --outfile=$@

=== bp/i86-mingw/Makefile ===
API = ../library
INCL = ../include
UTILS = ../utils
TEST = ../test
DAEMON = ../daemon
CGR = ../cgr
IPN = ../ipn
DTN2 = ../dtn2
LTP = ../ltp
TCP = ../tcp
DGR = ../dgr
BRS = ../brs
UDP = ../udp

OPT = -g -Wall -Werror -Dmingw
CC = gcc $(OPT) -I$(IPN) -I$(DTN2) -I$(API) -I$(INCL) -I$(ROOT)/include -DBP_EXTENDED
LDFLAGS = -fPIC -shared
LD = gcc $(LDFLAGS)

PUBINCLS = \
	$(INCL)/bp.h

BPINCLS = \
	$(API)/bpP.h \
	$(IPN)/ipnfw.h \
	$(DTN2)/dtn2fw.h \
	$(BRS)/brscla.h \
	$(UDP)/udpcla.h \
	$(TCP)/tcpcla.h \
	$(LTP)/ltpcla.h

BPLIBS = \
	libbp.dll

BPPOBJS = libbpP.o ecos.o bei.o extbsputil.o extbspbab.o crypto.o
# phn.o

LFW = -lipnfw -ldtn2fw

LBP = -lbp

RUNTIMES = bpadmin bpsink bpsource bpdriver bpecho bpcounter bpsendfile bprecvfile bpclock ipnadmin ipnfw ipnadminep dtn2admin dtn2fw dtn2adminep tcpcli tcpclo stcpcli stcpclo brsscla brsccla udpcli udpclo dgrcla ltpcli ltpclo lgsend lgagent bptrace bpstats bplist bpcancel hmackeys 
# bping bpstats2 bpchat

ALL = check $(BPLIBS) libcgr.dll libipnfw.dll libdtn2fw.dll libtcpcla.dll libudpcla.dll $(RUNTIMES)

all:		$(ALL)

check:		$(BPINCLS) $(PUBINCLS)
		rm -f *.o
		touch check

clean:
		rm -f *.o
		rm -f *.exe
		rm -f $(ALL)
		rm -f ./lib/*
		rm -f ./bin/*

install:
		cp ../include/* $(ROOT)/include
		cp lib/* $(ROOT)/lib
		cp bin/* $(ROOT)/bin

#	-	-	Daemon executables	-	-	-	-

bpclock:	bpclock.o $(BPLIBS)
		$(CC) -o bpclock bpclock.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpclock ./bin

#	-	-	Utility executables	-	-	-	-

bpadmin:	bpadmin.o $(BPLIBS)
		$(CC) -o bpadmin bpadmin.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpadmin ./bin

ipnadmin:	ipnadmin.o $(BPLIBS) libipnfw.dll
		$(CC) -o ipnadmin ipnadmin.o -L./lib -L$(ROOT)/lib -lipnfw $(LBP) -lici -lpthread
		cp ipnadmin ./bin

dtn2admin:	dtn2admin.o $(BPLIBS) libdtn2fw.dll
		$(CC) -o dtn2admin dtn2admin.o -L./lib -L$(ROOT)/lib -ldtn2fw $(LBP) -lici -lpthread
		cp dtn2admin ./bin

lgsend:		lgsend.o $(BPLIBS)
		$(CC) -o lgsend lgsend.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp lgsend ./bin

lgagent:	lgagent.o $(BPLIBS)
		$(CC) -o lgagent lgagent.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp lgagent ./bin

bptrace:	bptrace.o $(BPLIBS)
		$(CC) -o bptrace bptrace.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bptrace ./bin

bpstats:	bpstats.o $(BPLIBS)
		$(CC) -o bpstats bpstats.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpstats ./bin

bpstats2:	bpstats2.o $(BPLIBS)
		$(CC) -o bpstats2 bpstats2.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpstats2 ./bin

bping:		bping.o $(BPLIBS)
		$(CC) -o bping bping.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bping ./bin

bpchat:		bpchat.o $(BPLIBS)
		$(CC) -o bpchat bpchat.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpchat ./bin

bplist:		bplist.o $(BPLIBS)
		$(CC) -o bplist bplist.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bplist ./bin

bpcancel:	bpcancel.o $(BPLIBS)
		$(CC) -o bpcancel bpcancel.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpcancel ./bin

hmackeys:	hmackeys.o $(BPLIBS)
		$(CC) -o hmackeys hmackeys.o -L$(ROOT)/lib -lici -lpthread
		cp hmackeys ./bin

#	-	-	IPN executables	-	-	-	-	-

ipnfw:		ipnfw.o $(BPLIBS) libipnfw.dll libcgr.dll
		$(CC) -o ipnfw ipnfw.o -L./lib -L$(ROOT)/lib -lipnfw -lcgr $(LBP) -lici -lpthread
		cp ipnfw ./bin

ipnadminep:	ipnadminep.o $(BPLIBS) libipnfw.dll
		$(CC) -o ipnadminep ipnadminep.o -L./lib -L$(ROOT)/lib -lipnfw $(LBP) -lici -lpthread
		cp ipnadminep ./bin

#	-	-	DTN2 executables	-	-	-	-

dtn2fw:		dtn2fw.o $(BPLIBS) libdtn2fw.dll
		$(CC) -o dtn2fw dtn2fw.o -L./lib -L$(ROOT)/lib -ldtn2fw $(LBP) -lici -lpthread
		cp dtn2fw ./bin

dtn2adminep:	dtn2adminep.o $(BPLIBS) libdtn2fw.dll
		$(CC) -o dtn2adminep dtn2adminep.o -L./lib -L$(ROOT)/lib -ldtn2fw $(LBP) -lici -lpthread
		cp dtn2adminep ./bin

#	-	-	LTP executables	-	-	-	-	-

ltpcli:		ltpcli.o $(BPLIBS)
		$(CC) -o ltpcli ltpcli.o -L./lib -L$(ROOT)/lib $(LFW) $(LBP) -lltp -lici -lpthread
		cp ltpcli ./bin

ltpclo:		ltpclo.o $(BPLIBS)
		$(CC) -o ltpclo ltpclo.o -L./lib -L$(ROOT)/lib $(LBP) -lltp -lici -lpthread
		cp ltpclo ./bin

#	-	-	TCP executables	-	-	-	-	-

tcpcli:		tcpcli.o $(BPLIBS) libtcpcla.dll
		$(CC) -o tcpcli tcpcli.o -L./lib -L$(ROOT)/lib $(LFW) -ltcpcla $(LBP) -lici -lpthread -lws2_32
		cp tcpcli ./bin

tcpclo:		tcpclo.o $(BPLIBS) libtcpcla.dll
		$(CC) -o tcpclo tcpclo.o -L./lib -L$(ROOT)/lib -ltcpcla $(LBP) -lici -lpthread -lws2_32
		cp tcpclo ./bin

#	-	-	STCP executables	-	-	-	-

stcpcli:	stcpcli.o $(BPLIBS) libtcpcla.dll
		$(CC) -o stcpcli stcpcli.o -L./lib -L$(ROOT)/lib $(LFW) -ltcpcla $(LBP) -lici -lpthread -lws2_32
		cp stcpcli ./bin

stcpclo:	stcpclo.o $(BPLIBS) libtcpcla.dll
		$(CC) -o stcpclo stcpclo.o -L./lib -L$(ROOT)/lib -ltcpcla $(LBP) -lici -lpthread -lws2_32
		cp stcpclo ./bin

#	-	-	UDP executables	-	-	-	-	-

udpcli:		udpcli.o $(BPLIBS) libudpcla.dll
		$(CC) -o udpcli udpcli.o -L./lib -L$(ROOT)/lib $(LFW) -ludpcla $(LBP) -lici -lpthread -lws2_32
		cp udpcli ./bin

udpclo:		udpclo.o $(BPLIBS) libudpcla.dll
		$(CC) -o udpclo udpclo.o -L./lib -L$(ROOT)/lib -ludpcla $(LBP) -lici -lpthread -lws2_32
		cp udpclo ./bin

#	-	-	DGR executable	-	-	-	-	-

dgrcla:		dgrcla.o $(BPLIBS)
		$(CC) -o dgrcla dgrcla.o -L./lib -L$(ROOT)/lib $(LFW) $(LBP) -ldgr -lici -lpthread -lws2_32
		cp dgrcla ./bin

#	-	-	BRS executables	-	-	-	-

brsscla:	brsscla.o $(BPLIBS) libtcpcla.dll
		$(CC) -o brsscla brsscla.o -L./lib -L$(ROOT)/lib $(LFW) -ltcpcla $(LBP) -lici -lpthread -lws2_32
		cp brsscla ./bin

brsccla:	brsccla.o $(BPLIBS) libtcpcla.dll
		$(CC) -o brsccla brsccla.o -L./lib -L$(ROOT)/lib $(LFW) -ltcpcla $(LBP) -lici -lpthread -lws2_32
		cp brsccla ./bin

#	-	-	Test executables	-	-	-	-

bpsource:	bpsource.o libbp.dll $(BPLIBS)
		$(CC) -o bpsource bpsource.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpsource ./bin

bpsink:		bpsink.o libbp.dll $(BPLIBS)
		$(CC) -o bpsink bpsink.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpsink ./bin

bpdriver:	bpdriver.o libbp.dll $(BPLIBS)
		$(CC) -o bpdriver bpdriver.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpdriver ./bin

bpecho:		bpecho.o libbp.dll $(BPLIBS)
		$(CC) -o bpecho bpecho.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpecho ./bin

bpcounter:	bpcounter.o libbp.dll $(BPLIBS)
		$(CC) -o bpcounter bpcounter.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpcounter ./bin

bpsendfile:	bpsendfile.o libbp.dll $(BPLIBS)
		$(CC) -o bpsendfile bpsendfile.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpsendfile ./bin

bprecvfile:	bprecvfile.o libbp.dll $(BPLIBS)
		$(CC) -o bprecvfile bprecvfile.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bprecvfile ./bin

#	-	-	Libraries	-	-	-	-	-

libbp.dll:	libbp.o $(BPPOBJS)
		$(LD) -o libbp.dll libbp.o $(BPPOBJS) -L$(ROOT)/lib -lici -lpthread
		cp libbp.dll ./lib

libcgr.dll:	libcgr.o
		$(LD) -o libcgr.dll libcgr.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp libcgr.dll ./lib

libipnfw.dll:	libipnfw.o
		$(LD) -o libipnfw.dll libipnfw.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp libipnfw.dll ./lib

libdtn2fw.dll:	libdtn2fw.o
		$(LD) -o libdtn2fw.dll libdtn2fw.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp libdtn2fw.dll ./lib

libtcpcla.dll:	libtcpcla.o
		$(LD) -o libtcpcla.dll libtcpcla.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread -lws2_32
		cp libtcpcla.dll ./lib

libudpcla.dll:	libudpcla.o
		$(LD) -o libudpcla.dll libudpcla.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread -lws2_32
		cp libudpcla.dll ./lib

#	-	-	Object modules	-	-	-	-	-

%.o:		$(API)/%.c
		$(CC) -c $<

%.o:		$(API)/crypto/NULL_SUITES/%.c
		$(CC) -c $<

%.o:		$(API)/ext/ecos/%.c
		$(CC) -c $<

%.o:		$(API)/ext/bsp/%.c
		$(CC) -c $<

%.o:		$(API)/ext/phn/%.c
		$(CC) -c $<

%.o:		$(TEST)/%.c
		$(CC) -c $<

%.o:		$(UTILS)/%.c
		$(CC) -c $<

%.o:		$(DAEMON)/%.c
		$(CC) -c $<

%.o:		$(CGR)/%.c
		$(CC) -c $<

%.o:		$(IPN)/%.c
		$(CC) -c $<

%.o:		$(DTN2)/%.c
		$(CC) -c $<

%.o:		$(LTP)/%.c
		$(CC) -c $<

%.o:		$(TCP)/%.c
		$(CC) -c $<

%.o:		$(UDP)/%.c
		$(CC) -c $<

%.o:		$(BRS)/%.c
		$(CC) -c $<

%.o:		$(DGR)/%.c
		$(CC) -c $<

=== bp/i86-redhat/Makefile ===
API = ../library
INCL = ../include
UTILS = ../utils
TEST = ../test
DAEMON = ../daemon
CGR = ../cgr
IPN = ../ipn
DTN2 = ../dtn2
LTP = ../ltp
TCP = ../tcp
DGR = ../dgr
BRS = ../brs
UDP = ../udp
DCCP = ../dccp

# OPT = -O -Dlinux
OPT = -g -Wall -Werror -Dlinux
CC = gcc $(OPT) -I$(IPN) -I$(DTN2) -I$(API) -I$(INCL) -I$(ROOT)/include -DBP_EXTENDED
LDFLAGS = -fPIC -shared
LD = gcc $(LDFLAGS)

PUBINCLS = \
	$(INCL)/bp.h

BPINCLS = \
	$(API)/bpP.h \
	$(IPN)/ipnfw.h \
	$(DTN2)/dtn2fw.h \
	$(BRS)/brscla.h \
	$(UDP)/udpcla.h \
	$(TCP)/tcpcla.h \
	$(LTP)/ltpcla.h \
	$(DCCP)/dccpcla.h

BPLIBS = \
	libbp.so \
	libbpP.so

BPPOBJS = libbpP.o ecos.o bei.o extbsputil.o extbspbab.o crypto.o
# phn.o

LFW = -lipnfw -ldtn2fw

LBP = -lbp -lbpP

RUNTIMES = bpadmin bpsink bpsource bpdriver bpecho bpcounter bpsendfile bprecvfile bpclock ipnadmin ipnfw ipnadminep dtn2admin dtn2fw dtn2adminep tcpcli tcpclo stcpcli stcpclo brsscla brsccla udpcli udpclo dgrcla ltpcli ltpclo lgsend lgagent bptrace bpstats bplist bpcancel hmackeys bping bpstats2 bpchat
#dccpcli dccpclo

ALL = check $(BPLIBS) libcgr.so libipnfw.so libdtn2fw.so libtcpcla.so libudpcla.so $(RUNTIMES)

all:		$(ALL)

check:		$(BPINCLS) $(PUBINCLS)
		rm -f *.o
		touch check

clean:
		rm -f *.o
		rm -f $(ALL)
		rm -f ./lib/*
		rm -f ./bin/*

install:
		cp ../include/* $(ROOT)/include
		cp lib/* $(ROOT)/lib
		cp bin/* $(ROOT)/bin

#	-	-	Daemon executables	-	-	-	-

bpclock:	bpclock.o $(BPLIBS)
		$(CC) -o bpclock bpclock.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpclock ./bin

#	-	-	Utility executables	-	-	-	-

bpadmin:	bpadmin.o $(BPLIBS)
		$(CC) -o bpadmin bpadmin.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpadmin ./bin

ipnadmin:	ipnadmin.o $(BPLIBS) libipnfw.so
		$(CC) -o ipnadmin ipnadmin.o -L./lib -L$(ROOT)/lib -lipnfw $(LBP) -lici -lpthread
		cp ipnadmin ./bin

dtn2admin:	dtn2admin.o $(BPLIBS) libdtn2fw.so
		$(CC) -o dtn2admin dtn2admin.o -L./lib -L$(ROOT)/lib -ldtn2fw $(LBP) -lici -lpthread
		cp dtn2admin ./bin

lgsend:		lgsend.o $(BPLIBS)
		$(CC) -o lgsend lgsend.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp lgsend ./bin

lgagent:	lgagent.o $(BPLIBS)
		$(CC) -o lgagent lgagent.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp lgagent ./bin

bptrace:	bptrace.o $(BPLIBS)
		$(CC) -o bptrace bptrace.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bptrace ./bin

bpstats:	bpstats.o $(BPLIBS)
		$(CC) -o bpstats bpstats.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpstats ./bin

bpstats2:	bpstats2.o $(BPLIBS)
		$(CC) -o bpstats2 bpstats2.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpstats2 ./bin

bping:		bping.o $(BPLIBS)
		$(CC) -o bping bping.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bping ./bin

bpchat:		bpchat.o $(BPLIBS)
		$(CC) -o bpchat bpchat.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpchat ./bin

bplist:		bplist.o $(BPLIBS)
		$(CC) -o bplist bplist.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bplist ./bin

bpcancel:	bpcancel.o $(BPLIBS)
		$(CC) -o bpcancel bpcancel.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpcancel ./bin

hmackeys:	hmackeys.o $(BPLIBS)
		$(CC) -o hmackeys hmackeys.o -L$(ROOT)/lib -lici -lpthread
		cp hmackeys ./bin

#	-	-	IPN executables	-	-	-	-	-

ipnfw:		ipnfw.o $(BPLIBS) libipnfw.so libcgr.so
		$(CC) -o ipnfw ipnfw.o -L./lib -L$(ROOT)/lib -lipnfw -lcgr $(LBP) -lici -lpthread
		cp ipnfw ./bin

ipnadminep:	ipnadminep.o $(BPLIBS) libipnfw.so
		$(CC) -o ipnadminep ipnadminep.o -L./lib -L$(ROOT)/lib -lipnfw $(LBP) -lici -lpthread
		cp ipnadminep ./bin

#	-	-	DTN2 executables	-	-	-	-

dtn2fw:		dtn2fw.o $(BPLIBS) libdtn2fw.so
		$(CC) -o dtn2fw dtn2fw.o -L./lib -L$(ROOT)/lib -ldtn2fw $(LBP) -lici -lpthread
		cp dtn2fw ./bin

dtn2adminep:	dtn2adminep.o $(BPLIBS) libdtn2fw.so
		$(CC) -o dtn2adminep dtn2adminep.o -L./lib -L$(ROOT)/lib -ldtn2fw $(LBP) -lici -lpthread
		cp dtn2adminep ./bin

#	-	-	LTP executables	-	-	-	-	-

ltpcli:		ltpcli.o $(BPLIBS)
		$(CC) -o ltpcli ltpcli.o -L./lib -L$(ROOT)/lib $(LFW) $(LBP) -lltp -lltpP -lici -lpthread
		cp ltpcli ./bin

ltpclo:		ltpclo.o $(BPLIBS)
		$(CC) -o ltpclo ltpclo.o -L./lib -L$(ROOT)/lib $(LBP) -lltp -lltpP -lici -lpthread
		cp ltpclo ./bin

#	-	-	TCP executables	-	-	-	-	-

tcpcli:		tcpcli.o $(BPLIBS) libtcpcla.so
		$(CC) -o tcpcli tcpcli.o -L./lib -L$(ROOT)/lib $(LFW) -ltcpcla $(LBP) -lici -lpthread
		cp tcpcli ./bin

tcpclo:		tcpclo.o $(BPLIBS) libtcpcla.so
		$(CC) -o tcpclo tcpclo.o -L./lib -L$(ROOT)/lib -ltcpcla $(LBP) -lici -lpthread
		cp tcpclo ./bin

#	-	-	STCP executables	-	-	-	-

stcpcli:	stcpcli.o $(BPLIBS) libtcpcla.so
		$(CC) -o stcpcli stcpcli.o -L./lib -L$(ROOT)/lib $(LFW) -ltcpcla $(LBP) -lici -lpthread
		cp stcpcli ./bin

stcpclo:	stcpclo.o $(BPLIBS) libtcpcla.so
		$(CC) -o stcpclo stcpclo.o -L./lib -L$(ROOT)/lib -ltcpcla $(LBP) -lici -lpthread
		cp stcpclo ./bin

#	-	-	UDP executables	-	-	-	-	-

udpcli:		udpcli.o $(BPLIBS) libudpcla.so
		$(CC) -o udpcli udpcli.o -L./lib -L$(ROOT)/lib $(LFW) -ludpcla $(LBP) -lici -lpthread
		cp udpcli ./bin

udpclo:		udpclo.o $(BPLIBS) libudpcla.so
		$(CC) -o udpclo udpclo.o -L./lib -L$(ROOT)/lib -ludpcla $(LBP) -lici -lpthread
		cp udpclo ./bin

#	-	-	DCCP executables	-	-	-	-	-

dccpcli:	dccpcli.o $(BPLIBS)
		$(CC) -o dccpcli dccpcli.o -L./lib -L$(ROOT)/lib $(LFW) $(LBP) -lici -lpthread
		cp dccpcli ./bin

dccpclo:	dccpclo.o $(BPLIBS)
		$(CC) -o dccpclo dccpclo.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp dccpclo ./bin

#	-	-	DGR executable	-	-	-	-	-

dgrcla:		dgrcla.o $(BPLIBS)
		$(CC) -o dgrcla dgrcla.o -L./lib -L$(ROOT)/lib $(LFW) $(LBP) -ldgr -lici -lpthread
		cp dgrcla ./bin

#	-	-	BRS executables	-	-	-	-

brsscla:	brsscla.o $(BPLIBS) libtcpcla.so
		$(CC) -o brsscla brsscla.o -L./lib -L$(ROOT)/lib $(LFW) -ltcpcla $(LBP) -lici -lpthread
		cp brsscla ./bin

brsccla:	brsccla.o $(BPLIBS) libtcpcla.so
		$(CC) -o brsccla brsccla.o -L./lib -L$(ROOT)/lib $(LFW) -ltcpcla $(LBP) -lici -lpthread
		cp brsccla ./bin

#	-	-	Test executables	-	-	-	-

bpsource:	bpsource.o libbp.so $(BPLIBS)
		$(CC) -o bpsource bpsource.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpsource ./bin

bpsink:		bpsink.o libbp.so $(BPLIBS)
		$(CC) -o bpsink bpsink.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpsink ./bin

bpdriver:	bpdriver.o libbp.so $(BPLIBS)
		$(CC) -o bpdriver bpdriver.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpdriver ./bin

bpecho:		bpecho.o libbp.so $(BPLIBS)
		$(CC) -o bpecho bpecho.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpecho ./bin

bpcounter:	bpcounter.o libbp.so $(BPLIBS)
		$(CC) -o bpcounter bpcounter.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpcounter ./bin

bpsendfile:	bpsendfile.o libbp.so $(BPLIBS)
		$(CC) -o bpsendfile bpsendfile.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bpsendfile ./bin

bprecvfile:	bprecvfile.o libbp.so $(BPLIBS)
		$(CC) -o bprecvfile bprecvfile.o -L./lib -L$(ROOT)/lib $(LBP) -lici -lpthread
		cp bprecvfile ./bin

#	-	-	Libraries	-	-	-	-	-

libbpP.so:	$(BPPOBJS)
		$(LD) -o libbpP.so $(BPPOBJS)
		cp libbpP.so ./lib

libbp.so:	libbp.o
		$(LD) -o libbp.so libbp.o
		cp libbp.so ./lib

libcgr.so:	libcgr.o
		$(LD) -o libcgr.so libcgr.o
		cp libcgr.so ./lib

libipnfw.so:	libipnfw.o
		$(LD) -o libipnfw.so libipnfw.o
		cp libipnfw.so ./lib

libdtn2fw.so:	libdtn2fw.o
		$(LD) -o libdtn2fw.so libdtn2fw.o
		cp libdtn2fw.so ./lib

libtcpcla.so:	libtcpcla.o
		$(LD) -o libtcpcla.so libtcpcla.o
		cp libtcpcla.so ./lib

libudpcla.so:	libudpcla.o
		$(LD) -o libudpcla.so libudpcla.o
		cp libudpcla.so ./lib

#	-	-	Object modules	-	-	-	-	-

%.o:		$(API)/%.c
		$(CC) -c $<

%.o:		$(API)/crypto/NULL_SUITES/%.c
		$(CC) -c $<

%.o:		$(API)/ext/ecos/%.c
		$(CC) -c $<

%.o:		$(API)/ext/bsp/%.c
		$(CC) -c $<

#%.o:		$(API)/ext/phn/%.c
#		$(CC) -c $<

%.o:		$(TEST)/%.c
		$(CC) -c $<

%.o:		$(UTILS)/%.c
		$(CC) -c $<

%.o:		$(DAEMON)/%.c
		$(CC) -c $<

%.o:		$(CGR)/%.c
		$(CC) -c $<

%.o:		$(IPN)/%.c
		$(CC) -c $<

%.o:		$(DTN2)/%.c
		$(CC) -c $<

%.o:		$(LTP)/%.c
		$(CC) -c $<

%.o:		$(TCP)/%.c
		$(CC) -c $<

%.o:		$(UDP)/%.c
		$(CC) -c $<

#%.o:		$(DCCP)/%.c
#		$(CC) -c $<

%.o:		$(BRS)/%.c
		$(CC) -c $<

%.o:		$(DGR)/%.c
		$(CC) -c $<

=== cfdp/doc/Makefile ===
PODM1 = pod2man -s 1 -c "CFDP executables"
PODM3 = pod2man -s 3 -c "CFDP library functions"
PODM5 = pod2man -s 5 -c "CFDP configuration files"
PODH = pod2html --noindex

MANFILES = \
	./man/man1/cfdpadmin.1 \
	./man/man1/cfdpclock.1 \
	./man/man1/cfdptest.1 \
	./man/man1/bputa.1 \
	./man/man5/cfdprc.5 \
	./man/man3/cfdp.3

HTMLFILES = \
	./html/man1/cfdpadmin.html \
	./html/man1/cfdpclock.html \
	./html/man1/cfdptest.html \
	./html/man1/bputa.html \
	./html/man5/cfdprc.html \
	./html/man3/cfdp.html

ALL = $(MANFILES) $(HTMLFILES)

all:		$(ALL)

clean:
		rm -f man/man1/*.1
		rm -f man/man3/*.3
		rm -f man/man5/*.5
		rm -f html/man1/*.html
		rm -f html/man3/*.html
		rm -f html/man5/*.html
		rm -f *.tmp

install:
		cp man/man1/*.1 $(ROOT)/man/man1
		cp man/man3/*.3 $(ROOT)/man/man3
		cp man/man5/*.5 $(ROOT)/man/man5

#	-	-	Man files	-	-	-	-	-

./man/man1/%.1:	pod1/%.pod
		$(PODM1) $< $@

./man/man3/%.3:	pod3/%.pod
		$(PODM3) $< $@

./man/man5/%.5:	pod5/%.pod
		$(PODM5) $< $@

./html/man1/%.html:	pod1/%.pod
		$(PODH) --infile=$< --outfile=$@

./html/man3/%.html:	pod3/%.pod
		$(PODH) --infile=$< --outfile=$@

./html/man5/%.html:	pod5/%.pod
		$(PODH) --infile=$< --outfile=$@

=== cfdp/i86-darwin/Makefile ===
API = ../library
INCL = ../include
UTILS = ../utils
DAEMON = ../daemon
BP = ../bp
TEST = ../test

# OPT = -O -Dlinux
OPT = -g -Wall -Werror -Dunix -Ddarwin
CC = gcc $(OPT) -I$(API) -I$(INCL) -I$(ROOT)/include
LDFLAGS = -dynamiclib -undefined dynamic_lookup
LD = gcc $(LDFLAGS)

PUBINCLS = \
	$(INCL)/cfdp.h

CFDPINCLS = \
	$(API)/cfdpP.h

LBP = -lbp -lbpP

RUNTIMES = cfdpadmin cfdpclock bputa cfdptest

ALL = check libcfdpP.so libcfdp.so $(RUNTIMES)

all:		$(ALL)

check:		$(CFDPINCLS) $(PUBINCLS)
		rm -f *.o
		touch check

clean:
		rm -f *.o
		rm -f $(ALL)
		rm -f ./lib/*
		rm -f ./bin/*

install:
		cp ../include/* $(ROOT)/include
		cp lib/* $(ROOT)/lib
		cp bin/* $(ROOT)/bin

#	-	-	Daemon executables	-	-	-	-

cfdpclock:	cfdpclock.o libcfdpP.so
		$(CC) -o cfdpclock cfdpclock.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdpclock ./bin

#	-	-	Utility executables	-	-	-	-

cfdpadmin:	cfdpadmin.o libcfdpP.so
		$(CC) -o cfdpadmin cfdpadmin.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdpadmin ./bin

#	-	-	Test executables	-	-	-	-

cfdptest:	cfdptest.o libcfdpP.so libcfdp.so
		$(CC) -o cfdptest cfdptest.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdptest ./bin

#	-	-	BP executables	-	-	-	-	-

bputa:		bputa.o libcfdpP.so
		$(CC) -o bputa bputa.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp bputa ./bin

#	-	-	Libraries	-	-	-	-	-

libcfdpP.so:	libcfdpP.o
		$(LD) -o libcfdpP.so libcfdpP.o
		cp libcfdpP.so ./lib

libcfdp.so:	libcfdp.o libcfdpops.o
		$(LD) -o libcfdp.so libcfdp.o libcfdpops.o
		cp libcfdp.so ./lib

#	-	-	Object modules	-	-	-	-	-

%.o:		$(API)/%.c
		$(CC) -c $<

%.o:		$(UTILS)/%.c
		$(CC) -c $<

%.o:		$(TEST)/%.c
		$(CC) -c $<

%.o:		$(DAEMON)/%.c
		$(CC) -c $<

%.o:		$(BP)/%.c
		$(CC) -c $<

=== cfdp/i86-freebsd/Makefile ===
API = ../library
INCL = ../include
UTILS = ../utils
DAEMON = ../daemon
BP = ../bp
TEST = ../test

# OPT = -O -Dfreebsd
OPT = -g -Wall -Werror -Dfreebsd
CC = gcc $(OPT) -I$(API) -I$(INCL) -I$(ROOT)/include -DNO_PROXY -DNO_DIRLIST
LDFLAGS = -fPIC -shared
LD = gcc $(LDFLAGS)

PUBINCLS = \
	$(INCL)/cfdp.h

CFDPINCLS = \
	$(API)/cfdpP.h

LBP = -lbp -lbpP

RUNTIMES = cfdpadmin cfdpclock bputa cfdptest

ALL = check libcfdpP.so libcfdp.so $(RUNTIMES)

all:		$(ALL)

check:		$(CFDPINCLS) $(PUBINCLS)
		rm -f *.o
		touch check

clean:
		rm -f *.o
		rm -f $(ALL)
		rm -f ./lib/*
		rm -f ./bin/*

install:
		cp ../include/* $(ROOT)/include
		cp lib/* $(ROOT)/lib
		cp bin/* $(ROOT)/bin

#	-	-	Daemon executables	-	-	-	-

cfdpclock:	cfdpclock.o libcfdpP.so
		$(CC) -o cfdpclock cfdpclock.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdpclock ./bin

#	-	-	Utility executables	-	-	-	-

cfdpadmin:	cfdpadmin.o libcfdpP.so
		$(CC) -o cfdpadmin cfdpadmin.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdpadmin ./bin

#	-	-	Test executables	-	-	-	-

cfdptest:	cfdptest.o libcfdpP.so libcfdp.so
		$(CC) -o cfdptest cfdptest.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdptest ./bin

#	-	-	BP executables	-	-	-	-	-

bputa:		bputa.o libcfdpP.so
		$(CC) -o bputa bputa.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp bputa ./bin

#	-	-	Libraries	-	-	-	-	-

libcfdpP.so:	libcfdpP.o
		$(LD) -o libcfdpP.so libcfdpP.o
		cp libcfdpP.so ./lib

libcfdp.so:	libcfdp.o libcfdpops.o
		$(LD) -o libcfdp.so libcfdp.o libcfdpops.o
		cp libcfdp.so ./lib

#	-	-	Object modules	-	-	-	-	-

%.o:		$(API)/%.c
		$(CC) -c $<

%.o:		$(UTILS)/%.c
		$(CC) -c $<

%.o:		$(TEST)/%.c
		$(CC) -c $<

%.o:		$(DAEMON)/%.c
		$(CC) -c $<

%.o:		$(BP)/%.c
		$(CC) -c $<

=== cfdp/i86-mingw/Makefile ===
API = ../library
INCL = ../include
UTILS = ../utils
DAEMON = ../daemon
BP = ../bp
TEST = ../test

OPT = -g -Wall -Dmingw
CC = gcc $(OPT) -I$(API) -I$(INCL) -I$(ROOT)/include -DNO_PROXY -DNO_DIRLIST
LDFLAGS = -fPIC -shared
LD = gcc $(LDFLAGS)

PUBINCLS = \
	$(INCL)/cfdp.h

CFDPINCLS = \
	$(API)/cfdpP.h

LBP = -lbp

RUNTIMES = cfdpadmin cfdpclock bputa cfdptest

ALL = check libcfdp.dll $(RUNTIMES)

all:		$(ALL)

check:		$(CFDPINCLS) $(PUBINCLS)
		rm -f *.o
		touch check

clean:
		rm -f *.o
		rm -f *.exe
		rm -f $(ALL)
		rm -f ./lib/*
		rm -f ./bin/*

install:
		cp ../include/* $(ROOT)/include
		cp lib/* $(ROOT)/lib
		cp bin/* $(ROOT)/bin

#	-	-	Daemon executables	-	-	-	-

cfdpclock:	cfdpclock.o libcfdp.dll
		$(CC) -o cfdpclock cfdpclock.o -L./lib -L$(ROOT)/lib -lcfdp $(LBP) -lici -lpthread
		cp cfdpclock ./bin

#	-	-	Utility executables	-	-	-	-

cfdpadmin:	cfdpadmin.o libcfdp.dll
		$(CC) -o cfdpadmin cfdpadmin.o -L./lib -L$(ROOT)/lib -lcfdp $(LBP) -lici -lpthread
		cp cfdpadmin ./bin

#	-	-	Test executables	-	-	-	-

cfdptest:	cfdptest.o libcfdp.dll libcfdp.dll
		$(CC) -o cfdptest cfdptest.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdp $(LBP) -lici -lpthread
		cp cfdptest ./bin

#	-	-	BP executables	-	-	-	-	-

bputa:		bputa.o libcfdp.dll
		$(CC) -o bputa bputa.o -L./lib -L$(ROOT)/lib -lcfdp $(LBP) -lici -lpthread
		cp bputa ./bin

#	-	-	Libraries	-	-	-	-	-

libcfdp.dll:	libcfdpP.o libcfdp.o libcfdpops.o
		$(LD) -o libcfdp.dll libcfdpP.o libcfdp.o libcfdpops.o -L$(ROOT)/lib -lici -lpthread -lws2_32
		cp libcfdp.dll ./lib

#	-	-	Object modules	-	-	-	-	-

%.o:		$(API)/%.c
		$(CC) -c $<

%.o:		$(UTILS)/%.c
		$(CC) -c $<

%.o:		$(TEST)/%.c
		$(CC) -c $<

%.o:		$(DAEMON)/%.c
		$(CC) -c $<

%.o:		$(BP)/%.c
		$(CC) -c $<

=== cfdp/i86-redhat/Makefile ===
API = ../library
INCL = ../include
UTILS = ../utils
DAEMON = ../daemon
BP = ../bp
TEST = ../test

# OPT = -O -Dlinux
OPT = -g -Wall -Werror -Dlinux
CC = gcc $(OPT) -I$(API) -I$(INCL) -I$(ROOT)/include -DNO_PROXY -DNO_DIRLIST
LDFLAGS = -fPIC -shared
LD = gcc $(LDFLAGS)

PUBINCLS = \
	$(INCL)/cfdp.h

CFDPINCLS = \
	$(API)/cfdpP.h

LBP = -lbp -lbpP

RUNTIMES = cfdpadmin cfdpclock bputa cfdptest

ALL = check libcfdpP.so libcfdp.so $(RUNTIMES)

all:		$(ALL)

check:		$(CFDPINCLS) $(PUBINCLS)
		rm -f *.o
		touch check

clean:
		rm -f *.o
		rm -f $(ALL)
		rm -f ./lib/*
		rm -f ./bin/*

install:
		cp ../include/* $(ROOT)/include
		cp lib/* $(ROOT)/lib
		cp bin/* $(ROOT)/bin

#	-	-	Daemon executables	-	-	-	-

cfdpclock:	cfdpclock.o libcfdpP.so
		$(CC) -o cfdpclock cfdpclock.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdpclock ./bin

#	-	-	Utility executables	-	-	-	-

cfdpadmin:	cfdpadmin.o libcfdpP.so
		$(CC) -o cfdpadmin cfdpadmin.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdpadmin ./bin

#	-	-	Test executables	-	-	-	-

cfdptest:	cfdptest.o libcfdpP.so libcfdp.so
		$(CC) -o cfdptest cfdptest.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdptest ./bin

#	-	-	BP executables	-	-	-	-	-

bputa:		bputa.o libcfdpP.so
		$(CC) -o bputa bputa.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp bputa ./bin

#	-	-	Libraries	-	-	-	-	-

libcfdpP.so:	libcfdpP.o
		$(LD) -o libcfdpP.so libcfdpP.o
		cp libcfdpP.so ./lib

libcfdp.so:	libcfdp.o libcfdpops.o
		$(LD) -o libcfdp.so libcfdp.o libcfdpops.o
		cp libcfdp.so ./lib

#	-	-	Object modules	-	-	-	-	-

%.o:		$(API)/%.c
		$(CC) -c $<

%.o:		$(UTILS)/%.c
		$(CC) -c $<

%.o:		$(TEST)/%.c
		$(CC) -c $<

%.o:		$(DAEMON)/%.c
		$(CC) -c $<

%.o:		$(BP)/%.c
		$(CC) -c $<

=== cfdp/i86_64-fedora/Makefile ===
API = ../library
INCL = ../include
UTILS = ../utils
DAEMON = ../daemon
BP = ../bp
TEST = ../test

# OPT = -O -Dlinux
OPT = -g -Wall -Werror -Dlinux -fPIC
CC = gcc $(OPT) -I$(API) -I$(INCL) -I$(ROOT)/include
LDFLAGS = -fPIC -shared
LD = gcc $(LDFLAGS)

PUBINCLS = \
	$(INCL)/cfdp.h

CFDPINCLS = \
	$(API)/cfdpP.h

LBP = -lbp -lbpP

RUNTIMES = cfdpadmin cfdpclock bputa cfdptest

ALL = check libcfdpP.so libcfdp.so $(RUNTIMES)

all:		$(ALL)

check:		$(CFDPINCLS) $(PUBINCLS)
		rm -f *.o
		touch check

clean:
		rm -f *.o
		rm -f $(ALL)
		rm -f ./lib/*
		rm -f ./bin/*

install:
		cp ../include/* $(ROOT)/include
		cp lib/* $(ROOT)/lib
		cp bin/* $(ROOT)/bin

#	-	-	Daemon executables	-	-	-	-

cfdpclock:	cfdpclock.o libcfdpP.so
		$(CC) -o cfdpclock cfdpclock.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdpclock ./bin

#	-	-	Utility executables	-	-	-	-

cfdpadmin:	cfdpadmin.o libcfdpP.so
		$(CC) -o cfdpadmin cfdpadmin.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdpadmin ./bin

#	-	-	Test executables	-	-	-	-

cfdptest:	cfdptest.o libcfdpP.so libcfdp.so
		$(CC) -o cfdptest cfdptest.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp cfdptest ./bin

#	-	-	BP executables	-	-	-	-	-

bputa:		bputa.o libcfdpP.so
		$(CC) -o bputa bputa.o -L./lib -L$(ROOT)/lib -lcfdp -lcfdpP $(LBP) -lici -lpthread
		cp bputa ./bin

#	-	-	Libraries	-	-	-	-	-

libcfdpP.so:	libcfdpP.o
		$(LD) -o libcfdpP.so libcfdpP.o
		cp libcfdpP.so ./lib

libcfdp.so:	libcfdp.o libcfdpops.o
		$(LD) -o libcfdp.so libcfdp.o libcfdpops.o
		cp libcfdp.so ./lib

#	-	-	Object modules	-	-	-	-	-

%.o:		$(API)/%.c
		$(CC) -c $<

%.o:		$(UTILS)/%.c
		$(CC) -c $<

%.o:		$(TEST)/%.c
		$(CC) -c $<

%.o:		$(DAEMON)/%.c
		$(CC) -c $<

%.o:		$(BP)/%.c
		$(CC) -c $<

=== ici/doc/Makefile ===
PODM1 = pod2man -s 1 -c "ICI executables"
PODM3 = pod2man -s 3 -c "ICI library functions"
PODM5 = pod2man -s 5 -c "ICI configuration files"
PODH = pod2html --noindex

MANFILES = \
	./man/man1/ionadmin.1 \
	./man/man1/ionsecadmin.1 \
	./man/man1/rfxclock.1 \
	./man/man1/psmwatch.1 \
	./man/man1/sdrwatch.1 \
	./man/man1/sdrmend.1 \
	./man/man1/file2sdr.1 \
	./man/man1/file2sm.1 \
	./man/man1/psmshell.1 \
	./man/man1/sdr2file.1 \
	./man/man1/sm2file.1 \
	./man/man1/smlistsh.1 \
	./man/man1/owltsim.1 \
	./man/man1/owlttb.1 \
	./man/man5/ionconfig.5 \
	./man/man5/ionrc.5 \
	./man/man5/ionsecrc.5 \
	./man/man3/platform.3 \
	./man/man3/memmgr.3 \
	./man/man3/ion.3 \
	./man/man3/llcv.3 \
	./man/man3/lyst.3 \
	./man/man3/psm.3 \
	./man/man3/zco.3 \
	./man/man3/smlist.3 \
	./man/man3/sdrlist.3 \
	./man/man3/sdrstring.3 \
	./man/man3/sdrtable.3 \
	./man/man3/sdrhash.3 \
	./man/man3/sdr.3

HTMLFILES = \
	./html/man1/ionadmin.html \
	./html/man1/ionsecadmin.html \
	./html/man1/rfxclock.html \
	./html/man1/psmwatch.html \
	./html/man1/sdrwatch.html \
	./html/man1/sdrmend.html \
	./html/man1/file2sdr.html \
	./html/man1/file2sm.html \
	./html/man1/psmshell.html \
	./html/man1/sdr2file.html \
	./html/man1/sm2file.html \
	./html/man1/smlistsh.html \
	./html/man1/owltsim.html \
	./html/man1/owlttb.html \
	./html/man5/ionconfig.html \
	./html/man5/ionrc.html \
	./html/man5/ionsecrc.html \
	./html/man3/platform.html \
	./html/man3/memmgr.html \
	./html/man3/ion.html \
	./html/man3/llcv.html \
	./html/man3/lyst.html \
	./html/man3/psm.html \
	./html/man3/zco.html \
	./html/man3/smlist.html \
	./html/man3/sdrlist.html \
	./html/man3/sdrstring.html \
	./html/man3/sdrtable.html \
	./html/man3/sdrhash.html \
	./html/man3/sdr.html

ALL = $(MANFILES) $(HTMLFILES)

all:		$(ALL)

clean:
		rm -f man/man1/*.1
		rm -f man/man3/*.3
		rm -f man/man5/*.5
		rm -f html/man1/*.html
		rm -f html/man3/*.html
		rm -f html/man5/*.html
		rm -f *.tmp

install:
		cp man/man1/*.1 $(ROOT)/man/man1
		cp man/man3/*.3 $(ROOT)/man/man3
		cp man/man5/*.5 $(ROOT)/man/man5

#	-	-	Man files	-	-	-	-	-

./man/man1/%.1:	pod1/%.pod
		$(PODM1) $< $@

./man/man3/%.3:	pod3/%.pod
		$(PODM3) $< $@

./man/man5/%.5:	pod5/%.pod
		$(PODM5) $< $@

./html/man1/%.html:	pod1/%.pod
		$(PODH) --infile=$< --outfile=$@

./html/man3/%.html:	pod3/%.pod
		$(PODH) --infile=$< --outfile=$@

./html/man5/%.html:	pod5/%.pod
		$(PODH) --infile=$< --outfile=$@

=== ici/i86-mingw/Makefile ===
SRC = ../library
INCL = ../include
TEST = ../test
UTILS = ../utils
DAEMON = ../daemon
SDR = ../sdr

OPT = -g -Wall -Dmingw
CC = gcc $(OPT) -I$(SRC) -I$(TEST) -I$(SDR) -I$(INCL)
LDFLAGS = -fPIC -shared
LD = gcc $(LDFLAGS)

LIBICIOBJS = \
	llcv.o \
	platform.o \
	platform_sm.o \
	memmgr.o \
	lyst.o \
	psm.o \
	smlist.o \
	sptrace.o \
	ion.o \
	rfx.o \
	ionsec.o \
	zco.o \
	sdrxn.o \
	sdrmgt.o \
	sdrstring.o \
	sdrlist.o \
	sdrtable.o \
	sdrhash.o \
	sdrcatlg.o

PUBINCLS = \
	$(INCL)/llcv.h \
	$(INCL)/platform.h \
	$(INCL)/platform_sm.h \
	$(INCL)/memmgr.h \
	$(INCL)/lyst.h \
	$(INCL)/psm.h \
	$(INCL)/smlist.h \
	$(INCL)/sptrace.h \
	$(INCL)/ion.h \
	$(INCL)/rfx.h \
	$(INCL)/ionsec.h \
	$(INCL)/zco.h \
	$(INCL)/sdrxn.h \
	$(INCL)/sdrmgt.h \
	$(INCL)/sdrstring.h \
	$(INCL)/sdrlist.h \
	$(INCL)/sdrtable.h \
	$(INCL)/sdrhash.h \
	$(INCL)/sdr.h

ICIINCLS = \
	$(SRC)/lystP.h \
	$(SDR)/sdrP.h

UTILITIES = sdrwatch psmwatch ionadmin ionsecadmin sdrmend

TESTPGMS = file2sm sm2file file2sdr sdr2file psmshell smlistsh owltsim
# owlttb

ALL = check libici.dll rfxclock killm winion $(UTILITIES) $(TESTPGMS)

all:		$(ALL)

check:		$(ICIINCLS) $(PUBINCLS)
		rm -f *.o
		touch check

clean:
		rm -f *.o
		rm -f *.exe
		rm -f $(ALL)
		rm -f ./lib/*
		rm -f ./bin/*

install:
		cp ../include/*.h $(ROOT)/include
		cp lib/* $(ROOT)/lib
		cp bin/* $(ROOT)/bin

#	-	-	Utility executables	-	-	-	-

sdrwatch:	sdrwatch.o libici.dll
		$(CC) -o sdrwatch sdrwatch.o -L./lib -lici -lpthread
		cp sdrwatch ./bin

sdrmend:	sdrmend.o libici.dll
		$(CC) -o sdrmend sdrmend.o -L./lib -lici -lpthread
		cp sdrmend ./bin

psmwatch:	psmwatch.o libici.dll
		$(CC) -o psmwatch psmwatch.o -L./lib -lici -lpthread
		cp psmwatch ./bin

ionadmin:	ionadmin.o libici.dll
		$(CC) -o ionadmin ionadmin.o -L./lib -lici -lpthread
		cp ionadmin ./bin

ionsecadmin:	ionsecadmin.o libici.dll
		$(CC) -o ionsecadmin ionsecadmin.o -L./lib -lici -lpthread
		cp ionsecadmin ./bin

killm:		killm.o libici.dll
		$(CC) -o killm killm.o -L./lib -lici -lpthread
		cp killm ./bin

#	-	-	Test executables	-	-	-	-

psmshell:	psmshell.o libici.dll
		$(CC) -o psmshell psmshell.o -L./lib -lici -lpthread
		cp psmshell ./bin

smlistsh:	smlistsh.o libici.dll
		$(CC) -o smlistsh smlistsh.o -L./lib -lici -lpthread
		cp smlistsh ./bin

file2sm:	file2sm.o libici.dll
		$(CC) -I. -o file2sm file2sm.o -L./lib -lici -lpthread
		cp file2sm ./bin

sm2file:	sm2file.o libici.dll
		$(CC) -I. -o sm2file sm2file.o -L./lib -lici -lpthread
		cp sm2file ./bin

file2sdr:	file2sdr.o libici.dll
		$(CC) -I. -o file2sdr file2sdr.o -L./lib -lici -lpthread
		cp file2sdr ./bin

sdr2file:	sdr2file.o libici.dll
		$(CC) -o sdr2file sdr2file.o -L./lib -lici -lpthread
		cp sdr2file ./bin

owltsim:	owltsim.o libici.dll
		$(CC) -o owltsim owltsim.o -L./lib -lici -lpthread -lws2_32
		cp owltsim ./bin

owlttb:		owlttb.o libici.dll
		$(CC) -o owlttb owlttb.o -L./lib -lici -lpthread
		cp owlttb ./bin

#	-	-	Daemon executables	-	-	-	-

rfxclock:	rfxclock.o libici.dll
		$(CC) -I. -o rfxclock rfxclock.o -L./lib -lici -lpthread
		cp rfxclock ./bin

winion:		winion.o libici.dll
		$(CC) -I. -o winion winion.o -L./lib -lici -lpthread
		cp winion ./bin

#	-	-	Libraries	-	-	-	-	-

libici.dll:	$(LIBICIOBJS)
		$(LD) -o libici.dll $(LIBICIOBJS) -lpthread -lws2_32
		cp libici.dll ./lib

#	-	-	Object modules	-	-	-	-	-

%.o:		$(SRC)/%.c
		$(CC) -c $<

%.o:		$(SDR)/%.c
		$(CC) -c $<

%.o:		$(UTILS)/%.c
		$(CC) -c $<

%.o:		$(DAEMON)/%.c
		$(CC) -c $<

%.o:		$(TEST)/%.c
		$(CC) -c $<

=== debian/changelog ===
ion (2.5.3~dfsg1-2) unstable; urgency=low

  [ Leo Iannacone ]
  * Take out valgrind from build-depends. This fixes dependency 
    installability problem on multi architecture. Package not 
    mandatory for the build.

  [ Alessio Treglia ]
  * Enable parallel builds.

 -- Leo Iannacone <l3on@ubuntu.com>  Sat, 11 Feb 2012 13:12:25 +0100

ion (2.5.3~dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #658620)

 -- Leo Iannacone <l3on@ubuntu.com>  Wed, 01 Feb 2012 09:46:31 +0100

=== debian/control ===
Source: ion
Priority: extra
Maintainer: Leo Iannacone <l3on@ubuntu.com>
Build-Depends:
 debhelper (>= 8.1.3~),
 dh-autoreconf,
 ghostscript,
 groff,
 libexpat1-dev,
 procps,
 psutils
Standards-Version: 3.9.2
Section: net
Homepage: https://ion.ocp.ohiou.edu/
Vcs-Git: git://git.debian.org/collab-maint/ion.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/ion.git

Package: ion
Architecture: any
Depends:
 libion0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 ion-doc
Description: NASA implementation of Delay-Tolerant Networking (DTN)
 Interplanetary Overlay Network (ION) software distribution
 is an implementation of Delay-Tolerant Networking (DTN)
 architecture as described in Internet RFC 4838.
 .
 This is a suite of communication protocol implementations designed
 to support mission operation communications across an end-to-end
 interplanetary network, which might include on-board (flight) subnets,
 in-situ planetary or lunar networks, proximity links,
 deep space links, and terrestrial internets.
 .
 Included in the ION software distribution are the following packages:
  * ici (interplanetary communication infrastructure) a set of libraries
    that provide flight-software-compatible support for functions on
    which the other packages rely
  * bp (bundle protocol), an implementation of the Delay-Tolerant
    Networking (DTN) architecture's Bundle Protocol.
  * dgr (datagram retransmission), a UDP reliability system that implements
    congestion control and is designed for relatively high performance.
  * ltp (licklider transmission protocol), a DTN convergence layer for reliable
    transmission over links characterized by long or highly variable delay.
  * ams - an implementation of the CCSDS Asynchronous Message Service.
  * cfdp - a class-1 (Unacknowledged) implementation of the CCSDS File
    Delivery Protocol.
  .
  This package contains the binary files.

Package: libion0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: NASA implementation of Delay-Tolerant Networking (DTN) - main libraries
 Interplanetary Overlay Network (ION) software distribution
 is an implementation of Delay-Tolerant Networking (DTN)
 architecture as described in Internet RFC 4838.
 .
 This is a suite of communication protocol implementations designed
 to support mission operation communications across an end-to-end
 interplanetary network, which might include on-board (flight) subnets,
 in-situ planetary or lunar networks, proximity links,
 deep space links, and terrestrial internets.
 .
 Included in the ION software distribution are the following packages:
  * ici (interplanetary communication infrastructure) a set of libraries
 that provide flight-software-compatible support for functions on
 which the other packages rely
  * bp (bundle protocol), an implementation of the Delay-Tolerant
 Networking (DTN) architecture's Bundle Protocol.
  * dgr (datagram retransmission), a UDP reliability system that implements
 congestion control and is designed for relatively high performance.
  * ltp (licklider transmission protocol), a DTN convergence layer for reliable
 transmission over links characterized by long or highly variable delay.
  * ams - an implementation of the CCSDS Asynchronous Message Service.
  * cfdp - a class-1 (Unacknowledged) implementation of the CCSDS File
 Delivery Protocol.
  .
  This package contains the library files.

Package: libion-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libion0 (= ${binary:Version}),
 ${misc:Depends}
Suggests: ion-doc
Description: NASA implementation of Delay-Tolerant Networking (DTN) - development files
 Interplanetary Overlay Network (ION) software distribution
 is an implementation of Delay-Tolerant Networking (DTN)
 architecture as described in Internet RFC 4838.
 .
 This is a suite of communication protocol implementations designed
 to support mission operation communications across an end-to-end
 interplanetary network, which might include on-board (flight) subnets,
 in-situ planetary or lunar networks, proximity links,
 deep space links, and terrestrial internets.
 .
 Included in the ION software distribution are the following packages:
  * ici (interplanetary communication infrastructure) a set of libraries
 that provide flight-software-compatible support for functions on
 which the other packages rely
  * bp (bundle protocol), an implementation of the Delay-Tolerant
 Networking (DTN) architecture's Bundle Protocol.
  * dgr (datagram retransmission), a UDP reliability system that implements
 congestion control and is designed for relatively high performance.
  * ltp (licklider transmission protocol), a DTN convergence layer for reliable
 transmission over links characterized by long or highly variable delay.
  * ams - an implementation of the CCSDS Asynchronous Message Service.
  * cfdp - a class-1 (Unacknowledged) implementation of the CCSDS File
 Delivery Protocol.
  .
  This package contains the development files.

Package: ion-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends}
Recommends:
 ion
Description: Interplanetary Overlay Network - examples and documentation
 Interplanetary Overlay Network (ION) software distribution
 is an implementation of Delay-Tolerant Networking (DTN)
 architecture as described in Internet RFC 4838.
 .
 This is a suite of communication protocol implementations designed
 to support mission operation communications across an end-to-end
 interplanetary network, which might include on-board (flight) subnets,
 in-situ planetary or lunar networks, proximity links,
 deep space links, and terrestrial internets.
 .
 Included in the ION software distribution are the following packages:
  * ici (interplanetary communication infrastructure) a set of libraries
    that provide flight-software-compatible support for functions on
    which the other packages rely
  * bp (bundle protocol), an implementation of the Delay-Tolerant
    Networking (DTN) architecture's Bundle Protocol.
  * dgr (datagram retransmission), a UDP reliability system that implements
    congestion control and is designed for relatively high performance.
  * ltp (licklider transmission protocol), a DTN convergence layer for reliable
    transmission over links characterized by long or highly variable delay.
  * ams - an implementation of the CCSDS Asynchronous Message Service.
  * cfdp - a class-1 (Unacknowledged) implementation of the CCSDS File
    Delivery Protocol.
  .
  This package contains the documentation and some configuration example.
